from ..cloudbrain.download import download_dataset, download_pretrain_model
from ..cloudbrain.upload import upload_output

class OpeniContext:
    def __init__(self, dataset_path, pretrain_model_path):
        self.dataset_path = dataset_path
        self.pretrain_model_path = pretrain_model_path
        self.output_path = None

    def upload_openi(self):
        return upload_output(self.output_path)
        
def prepare():
    # 在prepare函数内部下载数据和模型，并初始化OpeniContext对象
    dataset_path = download_dataset()
    pretrain_model_path = download_pretrain_model()
    
    # 创建并返回OpeniContext对象
    return OpeniContext(dataset_path, pretrain_model_path)
